3 # Copyright (c) 2006 Johannes E. Schindelin
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
15 git-rebase [-i] [options] [--] <upstream> [<branch>]
16 git-rebase [-i] (--continue | --abort | --skip)
19 v,verbose display a diffstat of what changed upstream
20 onto= rebase onto given branch instead of upstream
21 p,preserve-merges try to recreate merges instead of ignoring them
22 s,strategy= use the given merge strategy
23 m,merge always used (no-op)
24 i,interactive always used (no-op)
26 continue continue rebasing process
27 abort abort rebasing process and restore original branch
28 skip skip current patch and continue rebasing process
29 no-verify override pre-rebase hook from stopping the operation
30 root rebase all reachable commmits up to the root(s)
36 DOTEST="$GIT_DIR/rebase-merge"
37 TODO="$DOTEST"/git-rebase-todo
40 SQUASH_MSG="$DOTEST"/message-squash
41 REWRITTEN="$DOTEST"/rewritten
42 DROPPED="$DOTEST"/dropped
47 OK_TO_SKIP_PRE_REBASE=
50 GIT_CHERRY_PICK_HELP=" After resolving the conflicts,
51 mark the corrected paths with 'git add <paths>', and
52 run 'git rebase --continue'"
53 export GIT_CHERRY_PICK_HELP
64 test $status != 0 && printf "%s\n" "$output"
73 run_pre_rebase_hook () {
74 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
75 test -x "$GIT_DIR/hooks/pre-rebase"
77 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
78 echo >&2 "The pre-rebase hook refused to rebase."
84 require_clean_work_tree () {
85 # test if working tree is dirty
86 git rev-parse --verify HEAD > /dev/null &&
87 git update-index --ignore-submodules --refresh &&
88 git diff-files --quiet --ignore-submodules &&
89 git diff-index --cached --quiet HEAD --ignore-submodules -- ||
90 die "Working tree is dirty"
93 ORIG_REFLOG_ACTION="$GIT_REFLOG_ACTION"
95 comment_for_reflog () {
96 case "$ORIG_REFLOG_ACTION" in
98 GIT_REFLOG_ACTION="rebase -i ($1)"
99 export GIT_REFLOG_ACTION
105 mark_action_done () {
106 sed -e 1q < "$TODO" >> "$DONE"
107 sed -e 1d < "$TODO" >> "$TODO".new
108 mv -f "$TODO".new "$TODO"
109 count=$(grep -c '^[^#]' < "$DONE")
110 total=$(($count+$(grep -c '^[^#]' < "$TODO")))
111 if test "$last_count" != "$count"
114 printf "Rebasing (%d/%d)\r" $count $total
115 test -z "$VERBOSE" || echo
120 sha1_and_parents="$(git rev-list --parents -1 "$1")"
121 case "$sha1_and_parents" in
123 git diff --cc $sha1_and_parents
126 git diff-tree -p "$1^!"
131 esac > "$DOTEST"/patch
132 test -f "$DOTEST"/message ||
133 git cat-file commit "$1" | sed "1,/^$/d" > "$DOTEST"/message
134 test -f "$DOTEST"/author-script ||
135 get_author_ident_from_commit "$1" > "$DOTEST"/author-script
150 grep '^[^#]' "$1" >/dev/null
155 case "$1" in -n) sha1=$2; no_ff=t ;; *) sha1=$1 ;; esac
156 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
157 test -d "$REWRITTEN" &&
158 pick_one_preserving_merges "$@" && return
159 if test ! -z "$REBASE_ROOT"
161 output git cherry-pick "$@"
164 parent_sha1=$(git rev-parse --verify $sha1^) ||
165 die "Could not get the parent of $sha1"
166 current_sha1=$(git rev-parse --verify HEAD)
167 if test "$no_ff$current_sha1" = "$parent_sha1"; then
168 output git reset --hard $sha1
169 test "a$1" = a-n && output git reset --soft $current_sha1
170 sha1=$(git rev-parse --short $sha1)
171 output warn Fast forward to $sha1
173 output git cherry-pick "$@"
177 pick_one_preserving_merges () {
188 sha1=$(git rev-parse $sha1)
190 if test -f "$DOTEST"/current-commit
192 if test "$fast_forward" = t
194 cat "$DOTEST"/current-commit | while read current_commit
196 git rev-parse HEAD > "$REWRITTEN"/$current_commit
198 rm "$DOTEST"/current-commit ||
199 die "Cannot write current commit's replacement sha1"
203 echo $sha1 >> "$DOTEST"/current-commit
205 # rewrite parents; if none were rewritten, we can fast-forward.
207 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
208 if test "$pend" = " "
212 while [ "$pend" != "" ]
214 p=$(expr "$pend" : ' \([^ ]*\)')
217 if test -f "$REWRITTEN"/$p
219 new_p=$(cat "$REWRITTEN"/$p)
221 # If the todo reordered commits, and our parent is marked for
222 # rewriting, but hasn't been gotten to yet, assume the user meant to
223 # drop it on top of the current HEAD
226 new_p=$(git rev-parse HEAD)
229 test $p != $new_p && fast_forward=f
230 case "$new_parents" in
232 ;; # do nothing; that parent is already there
234 new_parents="$new_parents $new_p"
238 if test -f "$DROPPED"/$p
241 replacement="$(cat "$DROPPED"/$p)"
242 test -z "$replacement" && replacement=root
243 pend=" $replacement$pend"
245 new_parents="$new_parents $p"
249 case $fast_forward in
251 output warn "Fast forward to $sha1"
252 output git reset --hard $sha1 ||
253 die "Cannot fast forward to $sha1"
256 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
260 # detach HEAD to current parent
261 output git checkout $first_parent 2> /dev/null ||
262 die "Cannot move HEAD to $first_parent"
265 case "$new_parents" in
267 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
270 author_script=$(get_author_ident_from_commit $sha1)
271 eval "$author_script"
272 msg="$(git cat-file commit $sha1 | sed -e '1,/^$/d')"
273 # No point in merging the first parent, that's HEAD
274 new_parents=${new_parents# $first_parent}
275 if ! GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
276 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
277 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
278 output git merge $STRATEGY -m "$msg" \
281 printf "%s\n" "$msg" > "$GIT_DIR"/MERGE_MSG
282 die_with_patch $sha1 "Error redoing merge $sha1"
286 output git cherry-pick "$@" ||
287 die_with_patch $sha1 "Could not pick $sha1"
296 *1[0-9]|*[04-9]) echo "$1"th;;
303 make_squash_message () {
304 if test -f "$SQUASH_MSG"; then
305 COUNT=$(($(sed -n "s/^# This is [^0-9]*\([1-9][0-9]*\).*/\1/p" \
306 < "$SQUASH_MSG" | sed -ne '$p')+1))
307 echo "# This is a combination of $COUNT commits."
308 sed -e 1d -e '2,/^./{
313 echo "# This is a combination of two commits."
314 echo "# The first commit's message is:"
316 git cat-file commit HEAD | sed -e '1,/^$/d'
319 echo "# This is the $(nth_string $COUNT) commit message:"
321 git cat-file commit $1 | sed -e '1,/^$/d'
324 peek_next_command () {
325 sed -n "1s/ .*$//p" < "$TODO"
329 rm -f "$DOTEST"/message "$DOTEST"/author-script \
330 "$DOTEST"/amend || exit
331 read command sha1 rest < "$TODO"
337 comment_for_reflog pick
341 die_with_patch $sha1 "Could not apply $sha1... $rest"
344 comment_for_reflog edit
348 die_with_patch $sha1 "Could not apply $sha1... $rest"
350 git rev-parse --verify HEAD > "$DOTEST"/amend
351 warn "Stopped at $sha1... $rest"
352 warn "You can amend the commit now, with"
354 warn " git commit --amend"
356 warn "Once you are satisfied with your changes, run"
358 warn " git rebase --continue"
363 comment_for_reflog squash
365 test -f "$DONE" && has_action "$DONE" ||
366 die "Cannot 'squash' without a previous commit"
369 make_squash_message $sha1 > "$MSG"
371 author_script=$(get_author_ident_from_commit HEAD)
372 output git reset --soft HEAD^
373 pick_one -n $sha1 || failed=t
374 case "$(peek_next_command)" in
379 cp "$MSG" "$SQUASH_MSG"
385 rm -f "$SQUASH_MSG" || exit
386 cp "$MSG" "$GIT_DIR"/SQUASH_MSG
387 rm -f "$GIT_DIR"/MERGE_MSG || exit
390 echo "$author_script" > "$DOTEST"/author-script
393 # This is like --amend, but with a different message
394 eval "$author_script"
395 GIT_AUTHOR_NAME="$GIT_AUTHOR_NAME" \
396 GIT_AUTHOR_EMAIL="$GIT_AUTHOR_EMAIL" \
397 GIT_AUTHOR_DATE="$GIT_AUTHOR_DATE" \
398 $USE_OUTPUT git commit --no-verify \
399 $MSG_OPT "$EDIT_OR_FILE" || failed=t
403 cp "$MSG" "$GIT_DIR"/MERGE_MSG
405 warn "Could not apply $sha1... $rest"
406 die_with_patch $sha1 ""
410 warn "Unknown command: $command $sha1 $rest"
411 die_with_patch $sha1 "Please fix this in the file $TODO."
414 test -s "$TODO" && return
416 comment_for_reflog finish &&
417 HEADNAME=$(cat "$DOTEST"/head-name) &&
418 OLDHEAD=$(cat "$DOTEST"/head) &&
419 SHORTONTO=$(git rev-parse --short $(cat "$DOTEST"/onto)) &&
420 NEWHEAD=$(git rev-parse HEAD) &&
423 message="$GIT_REFLOG_ACTION: $HEADNAME onto $SHORTONTO)" &&
424 git update-ref -m "$message" $HEADNAME $NEWHEAD $OLDHEAD &&
425 git symbolic-ref HEAD $HEADNAME
428 test ! -f "$DOTEST"/verbose ||
429 git diff-tree --stat $(cat "$DOTEST"/head)..HEAD
433 warn "Successfully rebased and updated $HEADNAME."
445 # check if no other options are set
447 test $# -eq 2 -a "$2" = '--' &&
449 test -z "$PRESERVE_MERGES" &&
450 test -z "$STRATEGY" &&
454 get_saved_options () {
455 test -d "$REWRITTEN" && PRESERVE_MERGES=t
456 test -f "$DOTEST"/strategy && STRATEGY="$(cat "$DOTEST"/strategy)"
457 test -f "$DOTEST"/verbose && VERBOSE=t
458 test -f "$DOTEST"/rebase-root && REBASE_ROOT=t
465 OK_TO_SKIP_PRE_REBASE=yes
470 is_standalone "$@" || usage
472 comment_for_reflog continue
474 test -d "$DOTEST" || die "No interactive rebase running"
477 git rev-parse --verify HEAD >/dev/null ||
478 die "Cannot read HEAD"
479 git update-index --ignore-submodules --refresh &&
480 git diff-files --quiet --ignore-submodules ||
481 die "Working tree is dirty"
483 # do we have anything to commit?
484 if git diff-index --cached --quiet --ignore-submodules HEAD --
486 : Nothing to commit -- skip this
488 . "$DOTEST"/author-script ||
489 die "Cannot find the author identity"
491 if test -f "$DOTEST"/amend
493 amend=$(git rev-parse --verify HEAD)
494 test "$amend" = $(cat "$DOTEST"/amend) ||
496 You have uncommitted changes in your working tree. Please, commit them
497 first and then run 'git rebase --continue' again."
498 git reset --soft HEAD^ ||
499 die "Cannot rewind the HEAD"
501 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE &&
502 git commit --no-verify -F "$DOTEST"/message -e || {
503 test -n "$amend" && git reset --soft $amend
504 die "Could not commit staged changes."
508 require_clean_work_tree
512 is_standalone "$@" || usage
514 comment_for_reflog abort
517 test -d "$DOTEST" || die "No interactive rebase running"
519 HEADNAME=$(cat "$DOTEST"/head-name)
520 HEAD=$(cat "$DOTEST"/head)
523 git symbolic-ref HEAD $HEADNAME
526 output git reset --hard $HEAD &&
531 is_standalone "$@" || usage
533 comment_for_reflog skip
536 test -d "$DOTEST" || die "No interactive rebase running"
538 output git reset --hard && do_rest
543 STRATEGY="-s "$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
552 # we use merge anyway
568 ONTO=$(git rev-parse --verify "$1") ||
569 die "Does not point to a valid commit: $1"
573 test -z "$REBASE_ROOT" -a $# -ge 1 -a $# -le 2 ||
574 test ! -z "$REBASE_ROOT" -a $# -le 1 || usage
576 die "Interactive rebase already started"
578 git var GIT_COMMITTER_IDENT >/dev/null ||
579 die "You need to set your committer info first"
581 if test -z "$REBASE_ROOT"
584 UPSTREAM=$(git rev-parse --verify "$1") || die "Invalid base"
585 test -z "$ONTO" && ONTO=$UPSTREAM
591 die "You must specify --onto when using --root"
593 run_pre_rebase_hook "$UPSTREAM_ARG" "$@"
595 comment_for_reflog start
597 require_clean_work_tree
601 output git show-ref --verify --quiet "refs/heads/$1" ||
602 die "Invalid branchname: $1"
603 output git checkout "$1" ||
604 die "Could not checkout $1"
607 HEAD=$(git rev-parse --verify HEAD) || die "No HEAD?"
608 mkdir "$DOTEST" || die "Could not create temporary $DOTEST"
610 : > "$DOTEST"/interactive || die "Could not mark as interactive"
611 git symbolic-ref HEAD > "$DOTEST"/head-name 2> /dev/null ||
612 echo "detached HEAD" > "$DOTEST"/head-name
614 echo $HEAD > "$DOTEST"/head
615 case "$REBASE_ROOT" in
617 rm -f "$DOTEST"/rebase-root ;;
619 : >"$DOTEST"/rebase-root ;;
621 echo $ONTO > "$DOTEST"/onto
622 test -z "$STRATEGY" || echo "$STRATEGY" > "$DOTEST"/strategy
623 test t = "$VERBOSE" && : > "$DOTEST"/verbose
624 if test t = "$PRESERVE_MERGES"
626 # $REWRITTEN contains files for each commit that is
627 # reachable by at least one merge base of $HEAD and
628 # $UPSTREAM. They are not necessarily rewritten, but
629 # their children might be.
630 # This ensures that commits on merged, but otherwise
631 # unrelated side branches are left alone. (Think "X"
632 # in the man page's example.)
633 if test -z "$REBASE_ROOT"
635 mkdir "$REWRITTEN" &&
636 for c in $(git merge-base --all $HEAD $UPSTREAM)
638 echo $ONTO > "$REWRITTEN"/$c ||
639 die "Could not init rewritten commits"
642 mkdir "$REWRITTEN" &&
643 echo $ONTO > "$REWRITTEN"/root ||
644 die "Could not init rewritten commits"
646 # No cherry-pick because our first pass is to determine
647 # parents to rewrite and skipping dropped commits would
648 # prematurely end our probe
650 first_after_upstream="$(git rev-list --reverse --first-parent $UPSTREAM..$HEAD | head -n 1)"
652 MERGES_OPTION="--no-merges --cherry-pick"
655 SHORTHEAD=$(git rev-parse --short $HEAD)
656 SHORTONTO=$(git rev-parse --short $ONTO)
657 if test -z "$REBASE_ROOT"
658 # this is now equivalent to ! -z "$UPSTREAM"
660 SHORTUPSTREAM=$(git rev-parse --short $UPSTREAM)
661 REVISIONS=$UPSTREAM...$HEAD
662 SHORTREVISIONS=$SHORTUPSTREAM..$SHORTHEAD
664 REVISIONS=$ONTO...$HEAD
665 SHORTREVISIONS=$SHORTHEAD
667 git rev-list $MERGES_OPTION --pretty=oneline --abbrev-commit \
668 --abbrev=7 --reverse --left-right --topo-order \
670 sed -n "s/^>//p" | while read shortsha1 rest
672 if test t != "$PRESERVE_MERGES"
674 echo "pick $shortsha1 $rest" >> "$TODO"
676 sha1=$(git rev-parse $shortsha1)
677 if test -z "$REBASE_ROOT"
680 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
682 if test -f "$REWRITTEN"/$p -a \( $p != $UPSTREAM -o $sha1 = $first_after_upstream \)
690 if test f = "$preserve"
692 touch "$REWRITTEN"/$sha1
693 echo "pick $shortsha1 $rest" >> "$TODO"
698 # Watch for commits that been dropped by --cherry-pick
699 if test t = "$PRESERVE_MERGES"
702 # Save all non-cherry-picked changes
703 git rev-list $REVISIONS --left-right --cherry-pick | \
704 sed -n "s/^>//p" > "$DOTEST"/not-cherry-picks
705 # Now all commits and note which ones are missing in
706 # not-cherry-picks and hence being dropped
707 git rev-list $REVISIONS |
710 if test -f "$REWRITTEN"/$rev -a "$(grep "$rev" "$DOTEST"/not-cherry-picks)" = ""
712 # Use -f2 because if rev-list is telling us this commit is
713 # not worthwhile, we don't want to track its multiple heads,
714 # just the history of its first-parent for others that will
715 # be rebasing on top of it
716 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$DROPPED"/$rev
717 short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
718 grep -v "^[a-z][a-z]* $short" <"$TODO" > "${TODO}2" ; mv "${TODO}2" "$TODO"
724 test -s "$TODO" || echo noop >> "$TODO"
725 cat >> "$TODO" << EOF
727 # Rebase $SHORTREVISIONS onto $SHORTONTO
730 # p, pick = use commit
731 # e, edit = use commit, but stop for amending
732 # s, squash = use commit, but meld into previous commit
734 # If you remove a line here THAT COMMIT WILL BE LOST.
735 # However, if you remove everything, the rebase will be aborted.
739 has_action "$TODO" ||
740 die_abort "Nothing to do"
742 cp "$TODO" "$TODO".backup
743 git_editor "$TODO" ||
744 die "Could not execute editor"
746 has_action "$TODO" ||
747 die_abort "Nothing to do"
749 git update-ref ORIG_HEAD $HEAD
750 output git checkout $ONTO && do_rest